module madds
   use precision, only: ki, ki_avh, ki_ql
   use constants
   use options
   use mfunctions
   use notfirst
   implicit none

     interface
        subroutine avh_olo_d0m(rslt,p1,p2,p3,p4,p12,p23,m1,m2,m3,m4)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: p1,p2,p3,p4,p12,p23,m1,m2,m3,m4
        end subroutine avh_olo_d0m
     end interface
     interface
        subroutine avh_olo_c0m(rslt,p1,p2,p3,m1,m2,m3)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: p1,p2,p3,m1,m2,m3
        end subroutine avh_olo_c0m
     end interface
     interface
        subroutine avh_olo_b11m(b11,b00,b1,b0,pp,m1,m2)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: b11(0:2), b00(0:2), b1(0:2), b0(0:2)
           real(ki_avh), intent(in) :: pp,m1,m2
        end subroutine avh_olo_b11m
     end interface
     interface
        subroutine avh_olo_a0m(rslt,mm)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: mm
        end subroutine avh_olo_a0m
     end interface

     interface
        function qlI4(p1,p2,p3,p4,s12,s23,m1,m2,m3,m4,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1,p2,p3,p4,s12,s23
           real(ki_ql), intent(in) :: m1,m2,m3,m4,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI4
        end function qlI4
     end interface
     interface
        function qlI3(p1,p2,p3,m1,m2,m3,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1,p2,p3
           real(ki_ql), intent(in) :: m1,m2,m3,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI3
        end function qlI3
     end interface
     interface
        function qlI2(p1,m1,m2,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1
           real(ki_ql), intent(in) :: m1,m2,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI2
        end function qlI2
     end interface
     interface
        function qlI1(m1,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: m1,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI1
        end function qlI1
     end interface
contains

  subroutine add4(nleg,c4,cut4,Vi,msq,tot4,tot4r,scale2)
      implicit none
      integer cut4,i,j1,j2,j3,j4,nleg
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      real(ki) :: scale2, m0, m1, m2, m3, V1, V2, V3, V21, V31, V32
      real(ki), dimension(4):: Vi1, Vi2, Vi3, Vi21, Vi31, Vi32
      complex(ki), dimension(-2:0), intent(out) :: tot4
      complex(ki), dimension(0:4), intent(in) :: c4
      complex(ki), intent(out) :: tot4r
      complex(ki) :: c40
      complex(ki_avh), dimension(0:2) :: vald0
      complex(ki) :: ctmp
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
         call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      j4=cut4/1000
      j3=(cut4-j4*1000)/100
      j2=(cut4-j4*1000-j3*100)/10
      j1=cut4-j4*1000-j3*100-j2*10

      m0=msq(j1)
      m1=msq(j2)
      m2=msq(j3)
      m3=msq(j4)

      do i=1,4
         Vi1(i)=Vi(j2,i)-Vi(j1,i)
         Vi2(i)=Vi(j3,i)-Vi(j1,i)
         Vi3(i)=Vi(j1,i)-Vi(j4,i)
         Vi21(i)=Vi(j3,i)-Vi(j2,i)
         Vi31(i)=Vi(j4,i)-Vi(j2,i)
         Vi32(i)=Vi(j4,i)-Vi(j3,i)
      enddo

      V1=sdot(Vi1,Vi1)
      V2=sdot(Vi2,Vi2)
      V3=sdot(Vi3,Vi3)
      V21=sdot(Vi21,Vi21)
      V31=sdot(Vi31,Vi31)
      V32=sdot(Vi32,Vi32)

      c40=c4(0)
      tot4r=-c4(4)/six

  1  Format(A3,I4,A1,I2,A5,D24.15,A1,D24.15,A3)

      if     (isca.eq.1) then
      do ep=-2,0
         ctmp=qlI4(real(V1,ki_ql),real(V21,ki_ql),real(V32,ki_ql),&
         &         real(V3,ki_ql),real(V2,ki_ql),real(V31,ki_ql),&
         &         real(m0,ki_ql),real(m1,ki_ql),real(m2,ki_ql),&
         &         real(m3,ki_ql),real(scale2,ki_ql),ep)
              tot4(ep)=c40*ctmp
         tot4(ep)=c40*ctmp
         if (verbosity.ge.2) write(20,1) &
     & 'I4(',cut4,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
      enddo
      elseif (isca.eq.2) then
         call avh_olo_d0m(vald0,&
         &                real(V1,ki_avh),real(V21,ki_avh),real(V32,ki_avh),&
         &                real(V3,ki_avh),real(V2,ki_avh),real(V31,ki_avh),&
         &                real(m0,ki_avh),real(m1,ki_avh),real(m2,ki_avh),&
         &                real(m3,ki_avh))
         do ep=-2,0
            tot4(ep)= c40*vald0(-ep) 
            if (verbosity.ge.2) write(20,1) &
            & 'I4(',cut4,',',ep,') = (',real(vald0(-ep)),',',aimag(vald0(-ep)),'  )' 
         enddo
      else
         print*, 'error in add4'
         stop
      endif
      tot4(0)=tot4(0) + tot4r
  end subroutine add4

  subroutine add3(nleg,c3,cut3,Vi,msq,tot3,tot3r,scale2)
      implicit none
      integer cut3,i,j1,j2,j3,nleg
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      real(ki) :: scale2, m0, m1, m2, V1, V2, V3
      real(ki), dimension(4):: Vi1, Vi2, Vi3
      complex(ki), dimension(-2:0), intent(out) :: tot3
      complex(ki), dimension(0:9), intent(in) :: c3
      complex(ki), intent(out) :: tot3r
      complex(ki) :: c30
      complex(ki_avh), dimension(0:2) :: valc0
      complex(ki) :: ctmp
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
         call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      j3=cut3/100
      j2=(cut3-j3*100)/10
      j1=cut3-j3*100-j2*10

      m0=msq(j1)
      m1=msq(j2)
      m2=msq(j3)

      do i=1,4
         Vi1(i)=Vi(j2,i)-Vi(j1,i)
         Vi2(i)=Vi(j3,i)-Vi(j2,i)
         Vi3(i)=Vi(j1,i)-Vi(j3,i)
      enddo

      V1=sdot(Vi1,Vi1)
      V2=sdot(Vi2,Vi2)
      V3=sdot(Vi3,Vi3)

      c30=c3(0)

      tot3r=+c3(7)/two

  1  Format(A3,I3,A1,I2,A5,D24.15,A1,D24.15,A3)

      if (isca.eq.1) then
         do ep=-2,0
            ctmp=qlI3(real(V1,ki_ql),real(V2,ki_ql),real(V3,ki_ql),&
            &         real(m0,ki_ql),real(m1,ki_ql),real(m2,ki_ql),&
            &         real(scale2,ki_ql),ep)
            tot3(ep)=c30*ctmp 
            if (verbosity.ge.2) write(20,1) &
            &'I3(',cut3,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
         enddo
      elseif  (isca.eq.2) then
          call avh_olo_c0m(valc0,real(V1,ki_avh),real(V2,ki_avh),real(V3,ki_avh),&
          &                real(m0,ki_avh),real(m1,ki_avh),real(m2,ki_avh))
          do ep=-2,0
             tot3(ep)= c30*valc0(-ep) 
             if (verbosity.ge.2) write(20,1) &
     &'I3(',cut3,',',ep,') = (',real(valc0(-ep)),',',aimag(valc0(-ep)),'  )' 
          enddo
      else
         print*, 'error in add3'
         stop
      endif
         tot3(0)=tot3(0) + tot3r
  end subroutine add3

      subroutine add2(nleg,c2,cut2,k1,k2,msq,tot2,tot2r,scale2)
      implicit none
      integer cut2,i1,i2,nleg
      real(ki), dimension(0:nleg-1) :: msq
      real(ki) :: scale2, m0, m1, K11, K12, B06
      real(ki), dimension(4):: k1, k2
      complex(ki), dimension(-2:0), intent(out) :: tot2
      complex(ki), dimension(0:9), intent(in) :: c2
      complex(ki), intent(out) :: tot2r
      integer :: ep
      complex(ki), dimension(-2:0) :: J0, J1, J00, J01, J11 
      complex(ki_avh), dimension(0:2) :: scf2, scf1, scf0, scf 
      complex(ki) :: bb, b0, b00
      real(ki) :: bkv
      integer :: i

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
         call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      i2=cut2/10
      i1=cut2-i2*10

      m0=msq(i1)
      m1=msq(i2)

      K11=sdot(K1,K1)
      K12=sdot(K1,K2)


      B06=-(K11-three*(m0+m1))/six

      tot2r= + B06*c2(9)

      if (isca.eq.1) then
         do ep=-2,0
            J00(ep)=qlI2(real(K11,ki_ql),real(m0,ki_ql),real(m0,ki_ql),&
            &            real(scale2,ki_ql),ep)
            J11(ep)=qlI2(real(K11,ki_ql),real(m1,ki_ql),real(m1,ki_ql),&
            &            real(scale2,ki_ql),ep)
            J01(ep)=qlI2(real(K11,ki_ql),real(m0,ki_ql),real(m1,ki_ql),&
            &            real(scale2,ki_ql),ep)
            J0(ep)=qlI1(real(m0,ki_ql),real(scale2,ki_ql),ep)
            J1(ep)=qlI1(real(m1,ki_ql),real(scale2,ki_ql),ep)
            if (verbosity.ge.2) then
!               write(20,*) 'J_00(',cut2,',',ep,')=',J00(ep)
!               write(20,*) 'J_11(',cut2,',',ep,')=',J11(ep)
               write(20,903) 'I2_0(',cut2,',',ep,')=',J01(ep)
!               write(20,*) 'J_0(',cut2,',',ep,')=',J0(ep)
!               write(20,*) 'J_1(',cut2,',',ep,')=',J1(ep)
            endif
            enddo
               
            if (abs(K11).gt.zip1) then

               do ep=-2,0
            tot2(ep)=-(K12*(two*K12*(m0 - m1)*c2(2) +  &
     &      K11*(-three*c2(1) + two*K12*c2(2)))*J0(ep))/(six*K11**2) &
     &      + ((two*K12**2*(m0 - m1)**2*c2(2) +  &
     &      K11*K12*(-three*m0*c2(1) + three*m1*c2(1) +  &
     &      two*K12*m0*c2(2) - four*K12*m1*c2(2)) +  &
     &      K11**2*(6*c2(0) + K12*(-three*c2(1) + two*K12*c2(2))))* &
     &      J01(ep))/(six*K11**2) +  &
     &      (K12*(two*K12*(m0 - m1)*c2(2) +  &
     &      K11*(-three*c2(1) + four*K12*c2(2)))*J1(ep))/(six*K11**2)
            enddo
      tot2(0)=tot2(0)+(K12**2*c2(2))/18.0_ki - (K12**2*m0*c2(2))/(six*K11) -  &
     &           (K12**2*m1*c2(2))/(six*K11) + B06*c2(9)
      else
         if (m1.eq.m0) then
          do ep=-2,0
          tot2(ep)=(c2(0) + (K12*(-three*c2(1) + two*K12*c2(2)))/six)*J00(ep)
          enddo
      tot2(0)=tot2(0)+B06*c2(9)
         else
      do ep=-2,0
      tot2(ep)=(K12*m0**2*(-three*m0*c2(1) + three*m1*c2(1) + two*K12*m0*c2(2))* &
           &     J00(ep))/(six*(m0 - m1)**3) + c2(0)*J01(ep) -  &
     &  (K12*m1*(m0*m1*(9*c2(1) - 6*K12*c2(2)) -  &
     &       6*m0**2*(c2(1) - K12*c2(2)) +  &
     &       m1**2*(-three*c2(1) + two*K12*c2(2)))*J11(ep))/ &
     &   (six*(m0 - m1)**3)
      enddo
      tot2(0)=tot2(0) + (-three*K12*m0*c2(1))/(four*(m0 - m1)) +  &
     &  (K12*m1*c2(1))/(four*m0 - four*m1) +  &
     &  (11.0_ki*K12**2*m0**2*c2(2))/(18.0_ki*(m0 - m1)**2) -  &
     &  (7.0_ki*K12**2*m0*m1*c2(2))/(18.0_ki*(m0 - m1)**2) +  &
     &  (K12**2*m1**2*c2(2))/(9.0_ki*(m0 - m1)**2) + B06*c2(9)
         endif
      endif

       elseif  (isca.eq.2) then
          bb=c2(0)
          b0=c2(1)
          b00=c2(2)
          bkv=K12
          call avh_olo_b11m(scf2,scf0,scf1,scf,real(K11,ki_avh),&
          &                 real(m0,ki_avh),real(m1,ki_avh))
          tot2(0)=bb*scf(0)+b0*bkv*scf1(0)+b00*bkv*bkv*scf2(0)
          tot2(0)=tot2(0)+ B06*c2(9)
          tot2(-1)=bb*scf(1)+b0*bkv*scf1(1)+b00*bkv*bkv*scf2(1)
          tot2(-2)=bb*scf(2)+b0*bkv*scf1(2)+b00*bkv*bkv*scf2(2)
          if (verbosity.ge.2) then
             do i=0,2
                write(20,903) 'B_0 (',cut2,',',-i,') = ',scf(i)
                write(20,903) 'B_1 (',cut2,',',-i,') =',scf1(i)
                write(20,903) 'B_11(',cut2,',',-i,') =',scf2(i)
             enddo
          endif
       else
          print*, 'error in add2'
          stop
       endif

 903  format(a5,I2,a1,I2,a4,2(D24.15))

  end subroutine add2

      subroutine add1(nleg,c1,cut1,msq,tot1,scale2)
      implicit none 
      integer, intent(in) :: nleg, cut1
      complex(ki), dimension(-2:0), intent(out) :: tot1
      complex(ki), dimension(0:4), intent(in) :: c1
      real(ki), dimension(0:nleg-1), intent(in) :: msq
      real(ki), intent(in) :: scale2
      integer ::j1
      real(ki) :: m0
      complex(ki_avh), dimension(0:2) :: vala0
      complex(ki) :: ctmp
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
         call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif
      j1=cut1

      m0=msq(j1)

  1   Format(A3,I2,A1,I2,A5,D24.15,A1,D24.15,A3)

      if      (isca.eq.1) then
         do ep=-2,0
            ctmp = qlI1(real(m0,ki_ql),real(scale2,ki_ql),ep)
            tot1(ep)=c1(0)*ctmp
            if (verbosity.ge.2) write(20,1) &
     & 'I1(',cut1,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
         enddo
      elseif  (isca.eq.2) then         
         call avh_olo_a0m(vala0,real(m0,ki_avh))
         do ep=-2,0
            tot1(ep)= c1(0)*vala0(-ep) 
            if (verbosity.ge.2) write(20,1) &
     & 'I1(',cut1,',',ep,') = (',real(vala0(-ep)),',',aimag(vala0(-ep)),'  )' 
         enddo
      else
         print*, 'error in add1'
         stop
      endif

  end subroutine add1

end module madds

